
#ifndef CLI_H
#define CLI_H

#define MAX_LOCAL_ARGV 32
#define MAX_LOCAL_PIPE 16

typedef struct cmd_t cmd_t;
typedef struct pipe_t pipe_t;
typedef struct stage_t stage_t;

struct cmd_t {
  long type;  /* Choose long, avoid compiler padding */
  char *name;
  const char *info;
  int (*func)(int argc, char **argv);
};

struct stage_t {
  pid_t pid;
  int argc;
  char **argv;
  int (*func)(int argc, char **argv);
};

struct pipe_t {
  int max;
  int pad;
  stage_t stage[MAX_LOCAL_PIPE];
};


int cli_main(void);
int cli_help(int argc, char **argv);

int cli_exec_redirect(stage_t *stage, int fd_in, int fd_out, int fd_close);
int cli_exec(int argc, char **argv);
int cli_chdir(int argc, char **argv);
int cli_checkpw(int verbose);
int cli_passwd(int argc, char **argv);
int cli_editor(int argc, char **argv);

#endif
