
#ifndef EDIT_H
#define EDIT_H

#include <termios.h>
#include "list.h"

#define MAX_LINE 1024
#define LOG_LINE 8

typedef struct termios term_t;
typedef struct edit_t edit_t;
typedef struct edit_he_t edit_he_t;

/* Entries in the history lists look like this.
 */
struct edit_he_t
{
  lnod_t ln;
  int    len; /* String length, not gap length as in edit_t */
  char   pad[4];
  char  *buf;
};

struct edit_t
{
  /* History editing.
   */
  list_t hist;
  lnod_t *here;

  /* Terminal handling.
   */
  tcflag_t save;

  /* Cursor position and gap length
   */
  int pos;
  int len;

  /* Largely unused for now.
   */
  int row;
  int col;
  int x;
  int y;

  /* This is where editing takes place.
   */
  char buf[MAX_LINE+1];
  char pad[7];
};

void edit_init(edit_t *eb);
void edit_reset(edit_t *eb);
void edit_line(edit_t *eb, char *prompt);
int  edit_parse(char *buf, int *argc, char **argv, int max);
int  edit_passwd(char *pw, size_t len);

#endif
