
#ifndef KEY_STORE_H
#define KEY_STORE_H

#include <stdint.h>
#include "ee.h"

int key_store_init(char *storename);
int key_store_match(key_store_t *src, size_t len);
int key_store_merge(key_store_t *src);

int find_nick(char *nick, key_entry_t **out);
int find_me(uint8_t pk[LEN_PK], key_entry_t **out);
int find_em(uint8_t pk[LEN_PK], key_entry_t **out);
int reserve_unused(key_entry_t **out);
int delete_nick(char *nick);
int create_nick(char *nick, char *tags, key_entry_t **out);
int update_nick(char *nick);
int set_em(key_entry_t **inout, uint8_t pk[LEN_PK]);

int create_envelope(envelope_t *env, nonce_t *nonce, char *nick);
int open_envelope(envelope_t *env, nonce_t *nonce, key_entry_t **out);

int create_update(update_t *upd, nonce_t *nonce, key_entry_t *a, key_entry_t *b);
int open_update(update_t *upd, nonce_t *nonce, key_entry_t *a, key_entry_t *b);

int create_efile(uint8_t *c, size_t clen, char **nick, uint32_t max, size_t h, size_t b);
int create_efile_helper(size_t len, int max, size_t *clen, size_t *h, size_t *b, size_t *d);
int open_efile(uint8_t *c, size_t clen, key_entry_t **pe, size_t *offs);

#endif
