
#include <stdlib.h>
#include "list.h"

#define LINK(p,v,s) {v->succ = s; v->pred = p; s->pred = v; p->succ = v;}


void list_init(list_t *l)
{
  l->first = (lnod_t *)(&l->null);
  l->null  = NULL;
  l->last  = (lnod_t *)l;
}


void list_insert_after(lnod_t *p, lnod_t *v)
{
  lnod_t *s;

  s = p->succ;
  LINK(p,v,s);
}


void list_insert_before(lnod_t *v, lnod_t *s)
{
  lnod_t *p;

  p = s->pred;
  LINK(p,v,s);
}


void list_add_head(list_t *l, lnod_t *v)
{
  lnod_t *p;
  lnod_t *s;

  p = (lnod_t *)(&l->first);
  s = p->succ;
  LINK(p,v,s);
}


void list_add_tail(list_t *l, lnod_t *v)
{
  lnod_t *p;
  lnod_t *s;

  s = (lnod_t *)(&l->null);
  p = s->pred;
  LINK(p,v,s);
}


void list_remove(lnod_t *v)
{
  lnod_t *p;
  lnod_t *s;

  p = v->pred;
  s = v->succ;
  p->succ = s;
  s->pred = p;
}


lnod_t *list_remove_head(list_t *l)
{
  lnod_t *v;

  v = l->first;
  if (v->succ != NULL) {
    list_remove(v);
    return v;
  }
  return NULL;
}


lnod_t *list_remove_tail(list_t *l)
{
  lnod_t *v;

  v = l->last;
  if (v->pred != NULL) {
    list_remove(v);
    return v;
  }
  return NULL;
}


void list_append(list_t *d, list_t *s)
{
  if (s->first->succ == NULL) {
    return;
  }
  s->last->succ = d->last->succ;
  d->last->succ = s->first;
  s->first->pred = d->last;
  d->last = s->last;

  s->first = (lnod_t *)(&s->null);
  s->last  = (lnod_t *)s;
}
