#ifndef LIST_H
#define LIST_H

typedef struct lnod_t lnod_t;

struct lnod_t {
  lnod_t *succ;
  lnod_t *pred;
};

typedef struct list_t list_t;

struct list_t {
  lnod_t *first;
  lnod_t *null;
  lnod_t *last;
};

void list_init(list_t *l);
void list_insert_after(lnod_t *p, lnod_t *v);
void list_insert_before(lnod_t *v, lnod_t *s);
void list_add_head(list_t *l, lnod_t *v);
void list_add_tail(list_t *l, lnod_t *v);
void list_remove(lnod_t *v);
void list_append(list_t *d, list_t *s);
lnod_t *list_remove_head(list_t *l);
lnod_t *list_remove_tail(list_t *l);

#endif
