
#ifndef VIZ_H
#define VIZ_H

#include <stdint.h>

typedef struct tile_t tile_t;
typedef struct canvas_t canvas_t;

struct tile_t {
  uint8_t i;
  uint8_t c;
};

struct canvas_t {
  uint8_t *buf;
  uint8_t *iso;
  tile_t *code;
  int mod;
  int wd;
  int ht;
  int pad;
};

void canvas_init(canvas_t *canvas, int wd, int ht, int type);
void canvas_free(canvas_t *canvas);
void canvas_line(canvas_t *canvas, int x, int y, int u, int v);
int  canvas_encode(canvas_t *canvas, int x, int y);
void key_print(int fd, uint8_t *buf, size_t len, int type, int mode);
void update_print(int fd, uint8_t *buf, size_t len, int type, int mode);

#endif
