
#include <stdio.h>
#include <time.h>
#include "zeit.h"


uint64_t zeit_now()
{
  timeval_t tv;
  uint64_t us;
  uint64_t s;

  (void)gettimeofday(&tv, NULL);

  us = (uint64_t)(tv.tv_usec % 1000000);
  s  = (uint64_t)(tv.tv_sec);

  return (s * 1000000) + us;
}


void zeit_timeval(timeval_t *tv, uint64_t n)
{
  int64_t us;
  int64_t s;

  us = n % 1000000;
  s  = n / 1000000;

  tv->tv_usec = (suseconds_t)us;
  tv->tv_sec  = (time_t)s;
}


char *zeit_ctime_r(uint64_t n, char buf[LEN_ZEIT])
{
  time_t t;

  t = (time_t)(n / 1000000);
  (void)ctime_r(&t, buf);
  buf[24] = '\0';
  buf[25] = '\0';
  return buf;
}


char *zeit_ctime(uint64_t n)
{
  time_t t;
  char *p;

  t = (time_t)(n / 1000000);
  p = ctime(&t);
  p[24] = '\0';
  p[25] = '\0';
  return p;
}


void zeit_encode(uint64_t n, uint8_t out[8])
{
  int i;

  for (i=0; i < 8; i++, n = n >> 8) {
    out[i] = (uint8_t)(n & 0xff);
  }
}


uint64_t zeit_decode(uint8_t out[8])
{
  uint64_t n;
  int i;

  n = 0;

  for (n=0, i=7; i >= 0; i--) {
    n = (n << 8) | out[i];
  }
  return n;
}

